/*
 * Copyright 2022 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WSOURCE_H
#define WSOURCE_H

#include "heat.h"
#include "wGroup.h"
#include "wFct0.h"
#include <vector>
#include <string>

using namespace tbox;

namespace heat
{

/**
 * @brief manage (volumic) heat sources
 */

class HEAT_API Source : public Group
{
public:
#ifndef SWIG
    std::shared_ptr<Fct0> f;
#endif
    Source(std::shared_ptr<MshData> _msh, int no, std::shared_ptr<Fct0> _f);
    Source(std::shared_ptr<MshData> _msh, std::string const &name, std::shared_ptr<Fct0> _f);
    virtual ~Source() { std::cout << "~Source()\n"; }

#ifndef SWIG
    virtual void write(std::ostream &out) const override;
#endif
};

} // namespace heat

#endif //WSOURCE_H
